Index: uspace/lib/c/generic/net/inet.c
===================================================================
--- uspace/lib/c/generic/net/inet.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/c/generic/net/inet.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,190 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ *  @{
+ */
+
+/** @file
+ * Internet protocol address conversion functions implementation.
+ */
+
+#include <net/socket_codes.h>
+#include <net/in.h>
+#include <net/in6.h>
+#include <net/inet.h>
+
+#include <errno.h>
+#include <mem.h>
+#include <stdio.h>
+#include <str.h>
+
+/** Prints the address into the character buffer.
+ *
+ *  @param[in] family	The address family.
+ *  @param[in] data	The address data.
+ *  @param[out] address	The character buffer to be filled.
+ *  @param[in] length	The buffer length.
+ *  @returns		EOK on success.
+ *  @returns		EINVAL if the data or address parameter is NULL.
+ *  @returns		ENOMEM if the character buffer is not long enough.
+ *  @returns		ENOTSUP if the address family is not supported.
+ */
+int
+inet_ntop(uint16_t family, const uint8_t *data, char *address, size_t length)
+{
+	if ((!data) || (!address))
+		return EINVAL;
+
+	switch (family) {
+	case AF_INET:
+		// check the output buffer size
+		if (length < INET_ADDRSTRLEN)
+			return ENOMEM;
+			
+		// fill the buffer with the IPv4 address
+		snprintf(address, length, "%hhu.%hhu.%hhu.%hhu",
+		    data[0], data[1], data[2], data[3]);
+
+		return EOK;
+
+	case AF_INET6:
+		// check the output buffer size
+		if (length < INET6_ADDRSTRLEN)
+			return ENOMEM;
+		
+		// fill the buffer with the IPv6 address
+		snprintf(address, length,
+		    "%hhx%hhx:%hhx%hhx:%hhx%hhx:%hhx%hhx:%hhx%hhx:%hhx%hhx:"
+		    "%hhx%hhx:%hhx%hhx",
+		    data[0], data[1], data[2], data[3], data[4], data[5],
+		    data[6], data[7], data[8], data[9], data[10], data[11],
+		    data[12], data[13], data[14], data[15]);
+		
+		return EOK;
+
+	default:
+		return ENOTSUP;
+	}
+}
+
+/** Parses the character string into the address.
+ *
+ *  If the string is shorter than the full address, zero bytes are added.
+ *
+ *  @param[in] family	The address family.
+ *  @param[in] address	The character buffer to be parsed.
+ *  @param[out] data	The address data to be filled.
+ *  @returns		EOK on success.
+ *  @returns		EINVAL if the data parameter is NULL.
+ *  @returns		ENOENT if the address parameter is NULL.
+ *  @returns		ENOTSUP if the address family is not supported.
+ */
+int inet_pton(uint16_t family, const char *address, uint8_t *data)
+{
+	/** The base number of the values. */
+	int base;
+	/** The number of bytes per a section. */
+	size_t bytes;
+	/** The number of bytes of the address data. */
+	int count;
+
+	const char *next;
+	char *last;
+	int index;
+	size_t shift;
+	unsigned long value;
+
+	if (!data)
+		return EINVAL;
+
+	// set the processing parameters
+	switch (family) {
+	case AF_INET:
+		count = 4;
+		base = 10;
+		bytes = 1;
+		break;
+
+	case AF_INET6:
+		count = 16;
+		base = 16;
+		bytes = 4;
+		break;
+
+	default:
+		return ENOTSUP;
+	}
+
+	// erase if no address
+	if (!address) {
+		bzero(data, count);
+		return ENOENT;
+	}
+
+	// process the string from the beginning
+	next = address;
+	index = 0;
+	do {
+		// if the actual character is set
+		if (next && *next) {
+
+			// if not on the first character
+			if (index) {
+				// move to the next character
+				++next;
+			}
+
+			// parse the actual integral value
+			value = strtoul(next, &last, base);
+			// remember the last problematic character
+			// should be either '.' or ':' but is ignored to be more
+			// generic
+			next = last;
+
+			// fill the address data byte by byte
+			shift = bytes - 1;
+			do {
+				// like little endian
+				data[index + shift] = value;
+				value >>= 8;
+			} while(shift --);
+
+			index += bytes;
+		} else {
+			// erase the rest of the address
+			bzero(data + index, count - index);
+			return EOK;
+		}
+	} while (index < count);
+
+	return EOK;
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/net/modules.c
===================================================================
--- uspace/lib/c/generic/net/modules.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/c/generic/net/modules.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,294 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+
+/** @file
+ * Generic module functions implementation. 
+ *
+ * @todo MAKE IT POSSIBLE TO REMOVE THIS FILE VIA EITHER REPLACING PART OF ITS
+ * FUNCTIONALITY OR VIA INTEGRATING ITS FUNCTIONALITY MORE TIGHTLY WITH THE REST
+ * OF THE SYSTEM.
+ */
+
+#include <async.h>
+#include <malloc.h>
+#include <err.h>
+#include <sys/time.h>
+
+#include <ipc/ipc.h>
+#include <ipc/services.h>
+
+#include <net/modules.h>
+
+/** The time between connect requests in microseconds. */
+#define MODULE_WAIT_TIME	(10 * 1000)
+
+/** Answers the call.
+ *
+ * @param[in] callid	The call identifier.
+ * @param[in] result	The message processing result.
+ * @param[in] answer	The message processing answer.
+ * @param[in] answer_count The number of answer parameters.
+ */
+void
+answer_call(ipc_callid_t callid, int result, ipc_call_t *answer,
+    int answer_count)
+{
+	// choose the most efficient answer function
+	if (answer || (!answer_count)) {
+		switch (answer_count) {
+		case 0:
+			ipc_answer_0(callid, (ipcarg_t) result);
+			break;
+		case 1:
+			ipc_answer_1(callid, (ipcarg_t) result,
+			    IPC_GET_ARG1(*answer));
+			break;
+		case 2:
+			ipc_answer_2(callid, (ipcarg_t) result,
+			    IPC_GET_ARG1(*answer), IPC_GET_ARG2(*answer));
+			break;
+		case 3:
+			ipc_answer_3(callid, (ipcarg_t) result,
+			    IPC_GET_ARG1(*answer), IPC_GET_ARG2(*answer),
+			    IPC_GET_ARG3(*answer));
+			break;
+		case 4:
+			ipc_answer_4(callid, (ipcarg_t) result,
+			    IPC_GET_ARG1(*answer), IPC_GET_ARG2(*answer),
+			    IPC_GET_ARG3(*answer), IPC_GET_ARG4(*answer));
+			break;
+		case 5:
+		default:
+			ipc_answer_5(callid, (ipcarg_t) result,
+			    IPC_GET_ARG1(*answer), IPC_GET_ARG2(*answer),
+			    IPC_GET_ARG3(*answer), IPC_GET_ARG4(*answer),
+			    IPC_GET_ARG5(*answer));
+			break;
+		}
+	}
+}
+
+/** Create bidirectional connection with the needed module service and registers
+ * the message receiver.
+ *
+ * @param[in] need	The needed module service.
+ * @param[in] arg1	The first parameter.
+ * @param[in] arg2	The second parameter.
+ * @param[in] arg3	The third parameter.
+ * @param[in] client_receiver The message receiver.
+ *
+ * @return		The phone of the needed service.
+ * @return		Other error codes as defined for the ipc_connect_to_me()
+ *			function.
+ */
+int bind_service(services_t need, ipcarg_t arg1, ipcarg_t arg2, ipcarg_t arg3,
+    async_client_conn_t client_receiver)
+{
+	return bind_service_timeout(need, arg1, arg2, arg3, client_receiver, 0);
+}
+
+/** Create bidirectional connection with the needed module service and registers
+ * the message receiver.
+ *
+ * @param[in] need	The needed module service.
+ * @param[in] arg1	The first parameter.
+ * @param[in] arg2	The second parameter.
+ * @param[in] arg3	The third parameter.
+ * @param[in] client_receiver The message receiver.
+ * @param[in] timeout	The connection timeout in microseconds. No timeout if
+ * 			set to zero (0).
+ *
+ * @return		The phone of the needed service.
+ * @return		ETIMEOUT if the connection timeouted.
+ * @return		Other error codes as defined for the ipc_connect_to_me()
+ *			function.
+ *
+ */
+int bind_service_timeout(services_t need, ipcarg_t arg1, ipcarg_t arg2,
+    ipcarg_t arg3, async_client_conn_t client_receiver, suseconds_t timeout)
+{
+	ERROR_DECLARE;
+	
+	/* Connect to the needed service */
+	int phone = connect_to_service_timeout(need, timeout);
+	if (phone >= 0) {
+		/* Request the bidirectional connection */
+		ipcarg_t phonehash;
+		if (ERROR_OCCURRED(ipc_connect_to_me(phone, arg1, arg2, arg3,
+		    &phonehash))) {
+			ipc_hangup(phone);
+			return ERROR_CODE;
+		}
+		async_new_connection(phonehash, 0, NULL, client_receiver);
+	}
+	
+	return phone;
+}
+
+/** Connects to the needed module.
+ *
+ * @param[in] need	The needed module service.
+ * @returns		The phone of the needed service.
+ */
+int connect_to_service(services_t need)
+{
+	return connect_to_service_timeout(need, 0);
+}
+
+/** Connects to the needed module.
+ *
+ *  @param[in] need	The needed module service.
+ *  @param[in] timeout	The connection timeout in microseconds. No timeout if
+ *			set to zero (0).
+ *  @returns		The phone of the needed service.
+ *  @returns		ETIMEOUT if the connection timeouted.
+ */
+int connect_to_service_timeout(services_t need, suseconds_t timeout)
+{
+	int phone;
+
+	// if no timeout is set
+	if (timeout <= 0)
+		return async_connect_me_to_blocking(PHONE_NS, need, 0, 0);
+
+	while (true) {
+		phone = async_connect_me_to(PHONE_NS, need, 0, 0);
+		if ((phone >= 0) || (phone != ENOENT))
+			return phone;
+
+		// end if no time is left
+		if (timeout <= 0)
+			return ETIMEOUT;
+
+		// wait the minimum of the module wait time and the timeout
+		usleep((timeout <= MODULE_WAIT_TIME) ?
+		    timeout : MODULE_WAIT_TIME);
+		timeout -= MODULE_WAIT_TIME;
+	}
+}
+
+/** Receives data from the other party.
+ *
+ * The received data buffer is allocated and returned.
+ *
+ * @param[out] data	The data buffer to be filled.
+ * @param[out] length	The buffer length.
+ * @returns		EOK on success.
+ * @returns		EBADMEM if the data or the length parameter is NULL.
+ * @returns		EINVAL if the client does not send data.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		Other error codes as defined for the
+ *			async_data_write_finalize() function.
+ */
+int data_receive(void **data, size_t *length)
+{
+	ERROR_DECLARE;
+
+	ipc_callid_t callid;
+
+	if (!data || !length)
+		return EBADMEM;
+
+	// fetch the request
+	if (!async_data_write_receive(&callid, length))
+		return EINVAL;
+
+	// allocate the buffer
+	*data = malloc(*length);
+	if (!*data)
+		return ENOMEM;
+
+	// fetch the data
+	if (ERROR_OCCURRED(async_data_write_finalize(callid, *data, *length))) {
+		free(data);
+		return ERROR_CODE;
+	}
+
+	return EOK;
+}
+
+/** Replies the data to the other party.
+ *
+ * @param[in] data	The data buffer to be sent.
+ * @param[in] data_length The buffer length.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the client does not expect the data.
+ * @returns		EOVERFLOW if the client does not expect all the data.
+ *			Only partial data are transfered.
+ * @returns		Other error codes as defined for the
+ *			async_data_read_finalize() function.
+ */
+int data_reply(void *data, size_t data_length)
+{
+	size_t length;
+	ipc_callid_t callid;
+
+	// fetch the request
+	if (!async_data_read_receive(&callid, &length))
+		return EINVAL;
+
+	// check the requested data size
+	if (length < data_length) {
+		async_data_read_finalize(callid, data, length);
+		return EOVERFLOW;
+	}
+
+	// send the data
+	return async_data_read_finalize(callid, data, data_length);
+}
+
+/** Refreshes answer structure and parameters count.
+ *
+ * Erases all attributes.
+ *
+ * @param[in,out] answer The message processing answer structure.
+ * @param[in,out] answer_count The number of answer parameters.
+ */
+void refresh_answer(ipc_call_t *answer, int *answer_count)
+{
+	if (answer_count)
+		*answer_count = 0;
+
+	if (answer) {
+		IPC_SET_RETVAL(*answer, 0);
+		// just to be precize
+		IPC_SET_METHOD(*answer, 0);
+		IPC_SET_ARG1(*answer, 0);
+		IPC_SET_ARG2(*answer, 0);
+		IPC_SET_ARG3(*answer, 0);
+		IPC_SET_ARG4(*answer, 0);
+		IPC_SET_ARG5(*answer, 0);
+	}
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/net/packet.c
===================================================================
--- uspace/lib/c/generic/net/packet.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/c/generic/net/packet.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,424 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ *  @{
+ */
+
+/** @file
+ *  Packet map and queue implementation.
+ *  This file has to be compiled with both the packet server and the client.
+ */
+
+#include <malloc.h>
+#include <mem.h>
+#include <fibril_synch.h>
+#include <unistd.h>
+#include <errno.h>
+#include <err.h>
+
+#include <sys/mman.h>
+
+#include <adt/generic_field.h>
+#include <net/packet.h>
+#include <net/packet_header.h>
+
+/** Packet map page size. */
+#define PACKET_MAP_SIZE	100
+
+/** Returns the packet map page index.
+ * @param[in] packet_id The packet identifier.
+ */
+#define PACKET_MAP_PAGE(packet_id)	(((packet_id) - 1) / PACKET_MAP_SIZE)
+
+/** Returns the packet index in the corresponding packet map page.
+ *  @param[in] packet_id The packet identifier.
+ */
+#define PACKET_MAP_INDEX(packet_id)	(((packet_id) - 1) % PACKET_MAP_SIZE)
+
+/** Type definition of the packet map page. */
+typedef packet_t packet_map_t[PACKET_MAP_SIZE];
+
+/** Type definition of the packet map page pointer. */
+typedef packet_map_t * packet_map_ref;
+
+/** Packet map.
+ * Maps packet identifiers to the packet references.
+ * @see generic_field.h
+ */
+GENERIC_FIELD_DECLARE(gpm, packet_map_t);
+
+/** Packet map global data. */
+static struct {
+	/** Safety lock. */
+	fibril_rwlock_t lock;
+	/** Packet map. */
+	gpm_t packet_map;
+} pm_globals;
+
+GENERIC_FIELD_IMPLEMENT(gpm, packet_map_t);
+
+/** Initializes the packet map.
+ *
+ * @returns		EOK on success.
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+int pm_init(void)
+{
+	ERROR_DECLARE;
+
+	fibril_rwlock_initialize(&pm_globals.lock);
+	fibril_rwlock_write_lock(&pm_globals.lock);
+	ERROR_PROPAGATE(gpm_initialize(&pm_globals.packet_map));
+	fibril_rwlock_write_unlock(&pm_globals.lock);
+	return EOK;
+}
+
+/** Finds the packet mapping.
+ *
+ * @param[in] packet_id	The packet identifier to be found.
+ * @returns		The found packet reference.
+ * @returns		NULL if the mapping does not exist.
+ */
+packet_t pm_find(packet_id_t packet_id)
+{
+	packet_map_ref map;
+	packet_t packet;
+
+	if (!packet_id)
+		return NULL;
+
+	fibril_rwlock_read_lock(&pm_globals.lock);
+	if (packet_id > PACKET_MAP_SIZE * gpm_count(&pm_globals.packet_map)) {
+		fibril_rwlock_read_unlock(&pm_globals.lock);
+		return NULL;
+	}
+	map = gpm_get_index(&pm_globals.packet_map, PACKET_MAP_PAGE(packet_id));
+	if (!map) {
+		fibril_rwlock_read_unlock(&pm_globals.lock);
+		return NULL;
+	}
+	packet = (*map) [PACKET_MAP_INDEX(packet_id)];
+	fibril_rwlock_read_unlock(&pm_globals.lock);
+	return packet;
+}
+
+/** Adds the packet mapping.
+ *
+ * @param[in] packet	The packet to be remembered.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is not valid.
+ * @returns		EINVAL if the packet map is not initialized.
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+int pm_add(packet_t packet)
+{
+	ERROR_DECLARE;
+
+	packet_map_ref map;
+
+	if (!packet_is_valid(packet))
+		return EINVAL;
+
+	fibril_rwlock_write_lock(&pm_globals.lock);
+
+	if (PACKET_MAP_PAGE(packet->packet_id) <
+	    gpm_count(&pm_globals.packet_map)) {
+		map = gpm_get_index(&pm_globals.packet_map,
+		    PACKET_MAP_PAGE(packet->packet_id));
+	} else {
+		do {
+			map = (packet_map_ref) malloc(sizeof(packet_map_t));
+			if (!map) {
+				fibril_rwlock_write_unlock(&pm_globals.lock);
+				return ENOMEM;
+			}
+			bzero(map, sizeof(packet_map_t));
+			if ((ERROR_CODE =
+			    gpm_add(&pm_globals.packet_map, map)) < 0) {
+				fibril_rwlock_write_unlock(&pm_globals.lock);
+				free(map);
+				return ERROR_CODE;
+			}
+		} while (PACKET_MAP_PAGE(packet->packet_id) >=
+		    gpm_count(&pm_globals.packet_map));
+	}
+
+	(*map) [PACKET_MAP_INDEX(packet->packet_id)] = packet;
+	fibril_rwlock_write_unlock(&pm_globals.lock);
+	return EOK;
+}
+
+/** Releases the packet map. */
+void pm_destroy(void)
+{
+	int count;
+	int index;
+	packet_map_ref map;
+	packet_t packet;
+
+	fibril_rwlock_write_lock(&pm_globals.lock);
+	count = gpm_count(&pm_globals.packet_map);
+	while (count > 0) {
+		map = gpm_get_index(&pm_globals.packet_map, count - 1);
+		for (index = PACKET_MAP_SIZE - 1; index >= 0; --index) {
+			packet = (*map)[index];
+			if (packet_is_valid(packet))
+				munmap(packet, packet->length);
+		}
+	}
+	gpm_destroy(&pm_globals.packet_map);
+	// leave locked
+}
+
+/** Add packet to the sorted queue.
+ *
+ * The queue is sorted in the ascending order.
+ * The packet is inserted right before the packets of the same order value.
+ *
+ * @param[in,out] first	The first packet of the queue. Sets the first packet of
+ *			the queue. The original first packet may be shifted by
+ *			the new packet.
+ * @param[in] packet	The packet to be added.
+ * @param[in] order	The packet order value.
+ * @param[in] metric	The metric value of the packet.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the first parameter is NULL.
+ * @returns		EINVAL if the packet is not valid.
+ */
+int pq_add(packet_t * first, packet_t packet, size_t order, size_t metric)
+{
+	packet_t item;
+
+	if (!first || !packet_is_valid(packet))
+		return EINVAL;
+
+	pq_set_order(packet, order, metric);
+	if (packet_is_valid(*first)) {
+		item = * first;
+		do {
+			if (item->order < order) {
+				if (item->next) {
+					item = pm_find(item->next);
+				} else {
+					item->next = packet->packet_id;
+					packet->previous = item->packet_id;
+					return EOK;
+				}
+			} else {
+				packet->previous = item->previous;
+				packet->next = item->packet_id;
+				item->previous = packet->packet_id;
+				item = pm_find(packet->previous);
+				if (item)
+					item->next = packet->packet_id;
+				else
+					*first = packet;
+				return EOK;
+			}
+		} while (packet_is_valid(item));
+	}
+	*first = packet;
+	return EOK;
+}
+
+/** Finds the packet with the given order.
+ *
+ * @param[in] first	The first packet of the queue.
+ * @param[in] order	The packet order value.
+ * @returns		The packet with the given order.
+ * @returns		NULL if the first packet is not valid.
+ * @returns		NULL if the packet is not found.
+ */
+packet_t pq_find(packet_t packet, size_t order)
+{
+	packet_t item;
+
+	if (!packet_is_valid(packet))
+		return NULL;
+
+	item = packet;
+	do {
+		if (item->order == order)
+			return item;
+
+		item = pm_find(item->next);
+	} while (item && (item != packet) && packet_is_valid(item));
+
+	return NULL;
+}
+
+/** Inserts packet after the given one.
+ *
+ * @param[in] packet	The packet in the queue.
+ * @param[in] new_packet The new packet to be inserted.
+ * @returns		EOK on success.
+ * @returns		EINVAL if etiher of the packets is invalid.
+ */
+int pq_insert_after(packet_t packet, packet_t new_packet)
+{
+	packet_t item;
+
+	if (!packet_is_valid(packet) || !packet_is_valid(new_packet))
+		return EINVAL;
+
+	new_packet->previous = packet->packet_id;
+	new_packet->next = packet->next;
+	item = pm_find(packet->next);
+	if (item)
+		item->previous = new_packet->packet_id;
+	packet->next = new_packet->packet_id;
+
+	return EOK;
+}
+
+/** Detach the packet from the queue.
+ *
+ * @param[in] packet	The packet to be detached.
+ * @returns		The next packet in the queue. If the packet is the first
+ *			one of the queue, this becomes the new first one.
+ * @returns		NULL if there is no packet left.
+ * @returns		NULL if the packet is not valid.
+ */
+packet_t pq_detach(packet_t packet)
+{
+	packet_t next;
+	packet_t previous;
+
+	if (!packet_is_valid(packet))
+		return NULL;
+
+	next = pm_find(packet->next);
+	if (next) {
+		next->previous = packet->previous;
+		previous = pm_find(next->previous);
+		if (previous)
+			previous->next = next->packet_id;
+	}
+	packet->previous = 0;
+	packet->next = 0;
+	return next;
+}
+
+/** Sets the packet order and metric attributes.
+ *
+ * @param[in] packeti	The packet to be set.
+ * @param[in] order	The packet order value.
+ * @param[in] metric	The metric value of the packet.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is invalid.
+ */
+int pq_set_order(packet_t packet, size_t order, size_t metric)
+{
+	if (!packet_is_valid(packet))
+		return EINVAL;
+
+	packet->order = order;
+	packet->metric = metric;
+	return EOK;
+}
+
+/** Sets the packet order and metric attributes.
+ *
+ * @param[in] packet	The packet to be set.
+ * @param[out] order	The packet order value.
+ * @param[out] metric	The metric value of the packet.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is invalid.
+ */
+int pq_get_order(packet_t packet, size_t *order, size_t *metric)
+{
+	if (!packet_is_valid(packet))
+		return EINVAL;
+
+	if (order)
+		*order = packet->order;
+
+	if (metric)
+		*metric = packet->metric;
+
+	return EOK;
+}
+
+/** Releases the whole queue.
+ *
+ * Detaches all packets of the queue and calls the packet_release() for each of
+ * them.
+ *
+ * @param[in] first	The first packet of the queue.
+ * @param[in] packet_release The releasing function called for each of the
+ *			packets after its detachment.
+ */
+void pq_destroy(packet_t first, void (*packet_release)(packet_t packet))
+{
+	packet_t actual;
+	packet_t next;
+
+	actual = first;
+	while (packet_is_valid(actual)) {
+		next = pm_find(actual->next);
+		actual->next = 0;
+		actual->previous = 0;
+		if(packet_release)
+			packet_release(actual);
+		actual = next;
+	}
+}
+
+/** Returns the next packet in the queue.
+ *
+ * @param[in] packet	The packet queue member.
+ * @returns		The next packet in the queue.
+ * @returns		NULL if there is no next packet.
+ * @returns		NULL if the packet is not valid.
+ */
+packet_t pq_next(packet_t packet)
+{
+	if (!packet_is_valid(packet))
+		return NULL;
+
+	return pm_find(packet->next);
+}
+
+/** Returns the previous packet in the queue.
+ *
+ * @param[in] packet	The packet queue member.
+ * @returns		The previous packet in the queue.
+ * @returns		NULL if there is no previous packet.
+ * @returns		NULL if the packet is not valid.
+ */
+packet_t pq_previous(packet_t packet)
+{
+	if (!packet_is_valid(packet))
+		return NULL;
+
+	return pm_find(packet->previous);
+}
+
+/** @}
+ */
